from microservices import redirectios
from microservices import receiveios
import string
import random
import socket
import struct
import hashlib
import time

ip = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))

# md5加密
def computeMD5(message):
    m = hashlib.md5()
    m.update(message.encode(encoding='utf-8'))
    return m.hexdigest()


# md5加密
def computeMD5upper(message):
    m = hashlib.md5()
    m.update(message.encode(encoding='utf-8'))
    return m.hexdigest().upper()


def idfacode():
    ret = ''
    a = "".join(random.sample(string.ascii_letters+string.digits, 8))
    b = "".join(random.sample(string.ascii_letters+string.digits, 4))
    c = "".join(random.sample(string.ascii_letters+string.digits, 4))
    d = "".join(random.sample(string.ascii_letters+string.digits, 4))
    e = "".join(random.sample(string.ascii_letters+string.digits, 12))
    i = (a+"-"+b+"-"+c+"-"+d+"-"+e).upper()
    ret += i
    return ret


def idfvcode():
    ret = ''
    a = "".join(random.sample(string.ascii_letters+string.digits, 8))
    b = "".join(random.sample(string.ascii_letters+string.digits, 4))
    c = "".join(random.sample(string.ascii_letters+string.digits, 4))
    d = "".join(random.sample(string.ascii_letters+string.digits, 4))
    e = "".join(random.sample(string.ascii_letters+string.digits, 12))
    i = (a+"-"+b+"-"+c+"-"+d+"-"+e).upper()
    ret += i
    return ret


# ------------------------点击的取值顺序-----------------
# idfa正常值，idfv为正常值；idfa_md5正常值，idfv_md5为正常值,deviceid取idfa，deviceid md5取idfa_md5
def test_atb1():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = computeMD5(i)
    redirectios.parms['idfv'] = v
    redirectios.parms['idfv_md5'] = computeMD5(v)
    redirectios.parms['ipv4'] = ip
    redirectios.send_request3('mURv22a', '')
    print(i)


# idfa>ipv4
# idfa为空，idfv为正常值；idfa_md5为空，idfv_md5为正常值,deviceid取ip
def test_atb2():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = ''
    redirectios.parms['idfa_md5'] = ''
    redirectios.parms['idfv'] = v
    redirectios.parms['idfv_md5'] = computeMD5(v)
    redirectios.parms['ipv4'] = ip
    redirectios.send_request3('mURv22a', '')
    print(i)


# ------------------------精准归因-----------------
# idfa正常值，idfv为正常值；idfa_md5正常值，idfv_md5为正常值,归因结果为idfa
def test_atb3():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = computeMD5(i)
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = i
    receiveios.data[0]['device_info']['idfa_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = i
    receiveios.data[0]['device_info']['device_id_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['device_id_type'] = 'idfa'
    receiveios.data[0]['device_info']['device_id_md5_type'] = 'idfa_md5'
    receiveios.send_request()
    print(i)


# idfa点击为小写，iafa激活为大写，无归因
def test_atb4():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i.lower()
    redirectios.parms['idfa_md5'] = ''
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = i
    receiveios.data[0]['device_info']['idfa_md5'] = ''
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = i
    receiveios.data[0]['device_info']['device_id_md5'] = ''
    receiveios.data[0]['device_info']['device_id_type'] = 'idfa'
    receiveios.data[0]['device_info']['device_id_md5_type'] = ''
    receiveios.send_request()
    print(i)




# idfa点击为大写，idfa激活为小写，无归因
def test_atb5():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = ''
    redirectios.send_request3('mURv22a', '')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = i.lower()
    receiveios.data[0]['device_info']['idfa_md5'] = ''
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = i.lower()
    receiveios.data[0]['device_info']['device_id_md5'] = ''
    receiveios.data[0]['device_info']['device_id_type'] = 'idfa'
    receiveios.data[0]['device_info']['device_id_md5_type'] = ''
    receiveios.send_request()
    print(i.lower())



# 激活中的idfa_md5与点击中的idfa_md5一致，点击中idfa正常，激活中idfa为空，归因结果为idfa_md5
def test_atb6():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = computeMD5(i)
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = ''
    receiveios.data[0]['device_info']['idfa_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = v
    receiveios.data[0]['device_info']['device_id_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['device_id_type'] = 'idfv'
    receiveios.data[0]['device_info']['device_id_md5_type'] = 'idfa_md5'
    receiveios.send_request()
    print(v)



# 激活中的idfa_md5与点击中的idfa_md5大小写不一致，点击中idfa_md5为小写，激活中idfa_md5为大写，不归因
def test_atb7():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = computeMD5(i)
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = ''
    receiveios.data[0]['device_info']['idfa_md5'] = computeMD5upper(i)
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = v
    receiveios.data[0]['device_info']['device_id_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['device_id_type'] = 'idfv'
    receiveios.data[0]['device_info']['device_id_md5_type'] = 'idfa_md5'
    receiveios.send_request()
    print(v)



# 激活中的idfa_md5与点击中的idfa_md5大小写不一致，点击中idfa_md5为大写，激活中idfa_md5为小写，不归因
def test_atb8():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i
    redirectios.parms['idfa_md5'] = computeMD5upper(i)
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = ''
    receiveios.data[0]['device_info']['idfa_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = v
    receiveios.data[0]['device_info']['device_id_md5'] = computeMD5(i)
    receiveios.data[0]['device_info']['device_id_type'] = 'idfv'
    receiveios.data[0]['device_info']['device_id_md5_type'] = 'idfa_md5'
    receiveios.send_request()
    print(v)
    print(computeMD5(i))



# idfa点击为小写，iafa激活为大写,idfa_md5点击有值，激活无值，实时侧添加md5加密值，归因方式为md5
def test_atb9():
    i = idfacode()
    v = idfvcode()
    redirectios.parms['idfa'] = i.lower()
    redirectios.parms['idfa_md5'] = computeMD5(i)
    redirectios.send_request3('mURv22a','')
    time.sleep(8)
    receiveios.data[0]['device_info']['idfa'] = i
    receiveios.data[0]['device_info']['idfa_md5'] = ''
    receiveios.data[0]['device_info']['idfv'] = v
    receiveios.data[0]['device_info']['idfv_md5'] = computeMD5(v)
    receiveios.data[0]['device_info']['device_id'] = i
    receiveios.data[0]['device_info']['device_id_md5'] = ''
    receiveios.data[0]['device_info']['device_id_type'] = 'idfa'
    receiveios.data[0]['device_info']['device_id_md5_type'] = ''
    receiveios.send_request()
    print(i)